Overview | Package | Class | Use | Tree | Deprecated | Index | Help
|  | BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

WebLogic Server 8.1 API Reference

## weblogic.apache.xml.serialize
Class XMLSerializer

    java.lang.Object
      |
      +--weblogic.apache.xml.serialize.BaseMarkupSerializer
            |
            +--weblogic.apache.xml.serialize.XMLSerializer

public class XMLSerializer
extends BaseMarkupSerializer

Implements an XML serializer supporting both DOM and SAX pretty serializing. For usage instructions see `Serializer`.

If an output stream is used, the encoding is taken from the output format (defaults to `UTF-8`). If a writer is used, make sure the writer uses the same encoding (if applies) as specified in the output format.

The serializer supports both DOM and SAX. SAX serializing is done by firing SAX events and using the serializer as a document handler. DOM serializing is done by calling `BaseMarkupSerializer.serialize(Document)` or by using DOM Level 3 `DOMWriter` and serializing with `DOMWriter.writeNode(java.io.OutputStream, org.w3c.dom.Node)`, `DOMWriter.writeToString(org.w3c.dom.Node)`.

If an I/O exception occurs while serializing, the serializer will not throw an exception directly, but only throw it at the end of serializing (either DOM or SAX's `DocumentHandler.endDocument()`.

For elements that are not specified as whitespace preserving, the serializer will potentially break long text lines at space boundaries, indent lines, and serialize elements on separate lines. Line terminators will be regarded as spaces, and spaces at beginning of line will be stripped.

See Also:
  `Serializer`

Field Summary
`protected static boolean` | `DEBUG`
`protected boolean` | `fDOML1`
`protected NamespaceSupport` | `fLocalNSBinder` stores all namespace bindings on the current element
`protected int` | `fNamespaceCounter`
`protected boolean` | `fNamespaces` Controls whether namespace fixup should be performed during the serialization.
`protected NamespaceSupport` | `fNSBinder` stores namespaces in scope
`protected SymbolTable` | `fSymbolTable` symbol table for serialization
`protected static java.lang.String` | `PREFIX`

Fields inherited from class weblogic.apache.xml.serialize.BaseMarkupSerializer
`_docTypePublicId, _docTypeSystemId, _encodingInfo, _format, _indenting, _prefixes, _printer, _started, fDOMError, fDOMErrorHandler, fDOMFilter, fFeatures, fStrBuffer`

Constructor Summary
`XMLSerializer()` Constructs a new serializer.
`XMLSerializer(OutputFormat format)` Constructs a new serializer.
`XMLSerializer(java.io.OutputStream output, OutputFormat format)` Constructs a new serializer that writes to the specified output stream using the specified output format.
`XMLSerializer(java.io.Writer writer, OutputFormat format)` Constructs a new serializer that writes to the specified writer using the specified output format.

Method Summary
`void` | `endElement(java.lang.String tagName)`
`void` | `endElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName)`
`void` | `endElementIO(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName)`
`protected java.lang.String` | `getEntityRef(int ch)`
`protected void` | `printEscaped(java.lang.String source)`
`protected void` | `printText(char[] chars, int start, int length, boolean preserveSpace, boolean unescaped)`
`protected void` | `printText(java.lang.String text, boolean preserveSpace, boolean unescaped)`
`protected void` | `printXMLChar(int ch)`
`boolean` | `reset()`
`protected void` | `serializeElement(org.w3c.dom.Element elem)` Called to serialize a DOM element.
`void` | `setNamespaces(boolean namespaces)` Deprecated. -- functionality could be removed
`void` | `setOutputFormat(OutputFormat format)`
`protected void` | `startDocument(java.lang.String rootTagName)` Called to serialize the document's DOCTYPE by the root element.
`void` | `startElement(java.lang.String tagName, org.xml.sax.AttributeList attrs)`
`void` | `startElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName, org.xml.sax.Attributes attrs)`

Methods inherited from class weblogic.apache.xml.serialize.BaseMarkupSerializer
`asContentHandler, asDocumentHandler, asDOMSerializer, attributeDecl, characters, characters, comment, comment, content, elementDecl, endCDATA, endDocument, endDTD, endEntity, endNonEscaping, endPrefixMapping, endPreserving, enterElementState, externalEntityDecl, fatalError, getElementState, getPrefix, ignorableWhitespace, internalEntityDecl, isDocumentState, leaveElementState, modifyDOMError, notationDecl, prepare, printCDATAText, printDoctypeURL, printEscaped, processingInstruction, processingInstructionIO, serialize, serialize, serialize, serializeNode, serializePreRoot, setDocumentLocator, setOutputByteStream, setOutputCharStream, skippedEntity, startCDATA, startDocument, startDTD, startEntity, startNonEscaping, startPrefixMapping, startPreserving, surrogates, unparsedEntityDecl`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEBUG

    protected static final boolean DEBUG

### fNSBinder

    protected NamespaceSupport fNSBinder

  stores namespaces in scope

### fLocalNSBinder

    protected NamespaceSupport fLocalNSBinder

  stores all namespace bindings on the current element

### fSymbolTable

    protected SymbolTable fSymbolTable

  symbol table for serialization

### fDOML1

    protected boolean fDOML1

### fNamespaceCounter

    protected int fNamespaceCounter

### PREFIX

    protected static final java.lang.String PREFIX

### fNamespaces

    protected boolean fNamespaces

  Controls whether namespace fixup should be performed during the serialization. NOTE: if this field is set to true the following fields need to be initialized: fNSBinder, fLocalNSBinder, fSymbolTable, XMLSymbols.EMPTY_STRING, fXmlSymbol, fXmlnsSymbol, fNamespaceCounter.

Constructor Detail

### XMLSerializer

    public XMLSerializer()

  Constructs a new serializer. The serializer cannot be used without calling `BaseMarkupSerializer.setOutputCharStream(java.io.Writer)` or `BaseMarkupSerializer.setOutputByteStream(java.io.OutputStream)` first.

### XMLSerializer

    public XMLSerializer(OutputFormat format)

  Constructs a new serializer. The serializer cannot be used without calling `BaseMarkupSerializer.setOutputCharStream(java.io.Writer)` or `BaseMarkupSerializer.setOutputByteStream(java.io.OutputStream)` first.

### XMLSerializer

    public XMLSerializer(java.io.Writer writer,
                         OutputFormat format)

  Constructs a new serializer that writes to the specified writer using the specified output format. If `format` is null, will use a default output format.

  Parameters:
    `writer` - The writer to use
    `format` - The output format to use, null for the default

### XMLSerializer

    public XMLSerializer(java.io.OutputStream output,
                         OutputFormat format)

  Constructs a new serializer that writes to the specified output stream using the specified output format. If `format` is null, will use a default output format.

  Parameters:
    `output` - The output stream to use
    `format` - The output format to use, null for the default

Method Detail

### setOutputFormat

    public void setOutputFormat(OutputFormat format)

  Overrides:
    setOutputFormat in class BaseMarkupSerializer

### setNamespaces

    public void setNamespaces(boolean namespaces)

  Deprecated. -- functionality could be removed
  This methods turns on namespace fixup algorithm during DOM serialization.

  Parameters:
    `namespaces` -
  See Also:
    `DOMWriter`

### startElement

    public void startElement(java.lang.String namespaceURI,
                             java.lang.String localName,
                             java.lang.String rawName,
                             org.xml.sax.Attributes attrs)
                      throws org.xml.sax.SAXException

### endElement

    public void endElement(java.lang.String namespaceURI,
                           java.lang.String localName,
                           java.lang.String rawName)
                    throws org.xml.sax.SAXException

### endElementIO

    public void endElementIO(java.lang.String namespaceURI,
                             java.lang.String localName,
                             java.lang.String rawName)
                      throws java.io.IOException

### startElement

    public void startElement(java.lang.String tagName,
                             org.xml.sax.AttributeList attrs)
                      throws org.xml.sax.SAXException

### endElement

    public void endElement(java.lang.String tagName)
                    throws org.xml.sax.SAXException

### startDocument

    protected void startDocument(java.lang.String rootTagName)
                          throws java.io.IOException

  Called to serialize the document's DOCTYPE by the root element. The document type declaration must name the root element, but the root element is only known when that element is serialized, and not at the start of the document.

  This method will check if it has not been called before (`BaseMarkupSerializer._started`), will serialize the document type declaration, and will serialize all pre-root comments and PIs that were accumulated in the document (see `BaseMarkupSerializer.serializePreRoot()`). Pre-root will be serialized even if this is not the first root element of the document.

### serializeElement

    protected void serializeElement(org.w3c.dom.Element elem)
                             throws java.io.IOException

  Called to serialize a DOM element. Equivalent to calling `startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)`, `endElement(java.lang.String, java.lang.String, java.lang.String)` and serializing everything inbetween, but better optimized.

  Overrides:
    serializeElement in class BaseMarkupSerializer

### getEntityRef

    protected java.lang.String getEntityRef(int ch)

  Overrides:
    getEntityRef in class BaseMarkupSerializer

### printEscaped

    protected void printEscaped(java.lang.String source)
                         throws java.io.IOException

  Overrides:
    printEscaped in class BaseMarkupSerializer

### printXMLChar

    protected final void printXMLChar(int ch)
                               throws java.io.IOException

### printText

    protected void printText(java.lang.String text,
                             boolean preserveSpace,
                             boolean unescaped)
                      throws java.io.IOException

  Overrides:
    printText in class BaseMarkupSerializer

### printText

    protected void printText(char[] chars,
                             int start,
                             int length,
                             boolean preserveSpace,
                             boolean unescaped)
                      throws java.io.IOException

  Overrides:
    printText in class BaseMarkupSerializer

### reset

    public boolean reset()

  Overrides:
    reset in class BaseMarkupSerializer

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Documentation is available at http://e-docs.bea.com/wls/docs81
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD